package cn.com.qmth.examcloud.marking.api.client;

import cn.com.qmth.examcloud.commons.web.redis.RedisClient;
import cn.com.qmth.examcloud.marking.api.MarkWorkCloudService;
import cn.com.qmth.examcloud.marking.api.request.GetMarkWorkReq;
import cn.com.qmth.examcloud.marking.api.request.SaveMarkWorkReq;
import cn.com.qmth.examcloud.marking.api.request.UpdateMarkWorkReq;
import cn.com.qmth.examcloud.marking.api.response.GetMarkWorkResp;
import cn.com.qmth.examcloud.marking.api.response.SaveMarkWorkResp;
import cn.com.qmth.examcloud.marking.api.response.UpdateMarkWorkResp;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

/**
 * @ClassName MarkWorkCloudServiceClient
 * @Description TODO
 * @Author nikang
 * @Date 2018/11/26 13:45
 * @Version 3.0
 */
@Service
public class MarkWorkCloudServiceClient extends BasicCloudClientSupport implements MarkWorkCloudService {
    @Autowired
    RestTemplate restTemplate;

    @Autowired
    private RedisClient redisClient;
    @Override
    protected RestTemplate getRestTemplate() {
        return restTemplate;
    }

    @Override
    protected RedisClient getRedisClient() {
        return redisClient;
    }

    @Override
    public GetMarkWorkResp getMarkWork(GetMarkWorkReq req) {
        return post("markWorks/getAll",req, GetMarkWorkResp.class);
    }

    @Override
    public SaveMarkWorkResp saveMarkWork(SaveMarkWorkReq req) {
        return post("markWorks/saveMarkWork",req, SaveMarkWorkResp.class);
    }

    @Override
    public UpdateMarkWorkResp updateMarkWork(UpdateMarkWorkReq req) {
        return post("markWorks/updateMarkWork",req, UpdateMarkWorkResp.class);
    }
}
