package cn.com.qmth.examcloud.core.oe.admin.client;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import cn.com.qmth.examcloud.commons.web.redis.RedisClient;
import cn.com.qmth.examcloud.core.oe.admin.api.ExamScoreDataCloudService;
import cn.com.qmth.examcloud.core.oe.admin.api.request.FindExamScoreDataReq;
import cn.com.qmth.examcloud.core.oe.admin.api.request.GetAuditDataReq;
import cn.com.qmth.examcloud.core.oe.admin.api.request.GetScoreDataReq;
import cn.com.qmth.examcloud.core.oe.admin.api.request.QueryCapturePhotoReq;
import cn.com.qmth.examcloud.core.oe.admin.api.request.QueryScoreDataReq;
import cn.com.qmth.examcloud.core.oe.admin.api.response.FindExamScoreDataResp;
import cn.com.qmth.examcloud.core.oe.admin.api.response.GetAuditDataResp;
import cn.com.qmth.examcloud.core.oe.admin.api.response.GetScoreDataResp;
import cn.com.qmth.examcloud.core.oe.admin.api.response.QueryCapturePhotoResp;
import cn.com.qmth.examcloud.core.oe.admin.api.response.QueryScoreDataResp;

@Service
public class ExamScoreDataCloudServiceClient extends AdminCloudClientSupport implements ExamScoreDataCloudService{

	/**
	 * 
	 */
	private static final long serialVersionUID = 702370114207337204L;

	@Autowired
    private RestTemplate restTemplate;
	
    @Autowired
    private RedisClient redisClient;
    
	@Override
	protected RestTemplate getRestTemplate() {
		return restTemplate;
	}

	@Override
	protected RedisClient getRedisClient() {
		return redisClient;
	}
	
	@Override
	public FindExamScoreDataResp findExamScoreDataByScoreId(FindExamScoreDataReq findExamScoreDataReq) {
		return post("examScoreData/findExamScoreDataByScoreId", findExamScoreDataReq, FindExamScoreDataResp.class);
	}

	@Override
	public FindExamScoreDataResp findExamScoreDataByExamIdAndStudentCode(FindExamScoreDataReq findExamScoreDataReq) {
		return post("examScoreData/findExamScoreDataByExamIdAndStudentCode", findExamScoreDataReq, FindExamScoreDataResp.class);
	}

	@Override
	public GetScoreDataResp getScoreData(GetScoreDataReq req) {
		return post("examScoreData/getScoreData",req,GetScoreDataResp.class);
	}

	@Override
	public GetAuditDataResp getAuditData(GetAuditDataReq req) {
		return post("examScoreData/getAuditData",req,GetAuditDataResp.class);
	}

	@Override
	public QueryCapturePhotoResp queryCapturePhoto(QueryCapturePhotoReq req) {
		return post("examScoreData/queryCapturePhoto",req,QueryCapturePhotoResp.class);
	}

	@Override
	public QueryScoreDataResp queryScoreData(QueryScoreDataReq req) {
		return post("examScoreData/queryScoreData",req,QueryScoreDataResp.class);
	}
}
