package cn.com.qmth.examcloud.core.oe.admin.client;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import cn.com.qmth.examcloud.commons.web.redis.RedisClient;
import cn.com.qmth.examcloud.core.oe.admin.api.ExamScoreObtainQueueCloudService;
import cn.com.qmth.examcloud.core.oe.admin.api.request.DeleteExamScoreQueueReq;
import cn.com.qmth.examcloud.core.oe.admin.api.request.GetTopExamScoreQueueReq;
import cn.com.qmth.examcloud.core.oe.admin.api.response.GetTopExamScoreQueueResp;

@Service
public class ExamScoreObtainQueueCloudServiceClient extends AdminCloudClientSupport implements ExamScoreObtainQueueCloudService{

	/**
	 * 
	 */
	private static final long serialVersionUID = 7442463539981662202L;

	@Autowired
    private RestTemplate restTemplate;
	
    @Autowired
    private RedisClient redisClient;
	
	@Override
	public GetTopExamScoreQueueResp getTopExamScoreQueue(GetTopExamScoreQueueReq req) {
		return post("examScoreObtainQueue/getTopExamScoreQueue", req, GetTopExamScoreQueueResp.class);
	}

	@Override
	public void deleteExamScoreQueue(DeleteExamScoreQueueReq req) {
		post("examScoreObtainQueue/deleteExamScoreQueue", req);
	}

	@Override
	protected RestTemplate getRestTemplate() {
		return restTemplate;
	}

	@Override
	protected RedisClient getRedisClient() {
		return redisClient;
	}

}
