package cn.com.qmth.examcloud.exchange.inner.api.client;

import java.io.File;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import com.google.common.collect.Maps;

import cn.com.qmth.examcloud.commons.web.redis.RedisClient;
import cn.com.qmth.examcloud.exchange.inner.api.UpyunCloudService;
import cn.com.qmth.examcloud.exchange.inner.api.request.PutFileReq;
import cn.com.qmth.examcloud.exchange.inner.api.response.PutFileResp;

/**
 * 类注释
 *
 * @author WANGWEI
 * @date 2018年11月27日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
@Service
public class UpyunCloudServiceClient extends ExchangeCloudClientSupport
		implements
			UpyunCloudService {

	private static final long serialVersionUID = -7928075025404055161L;

	@Autowired
	RestTemplate restTemplate;

	@Autowired
	private RedisClient redisClient;

	@Override
	protected RedisClient getRedisClient() {
		return redisClient;
	}

	@Override
	protected RestTemplate getRestTemplate() {
		return restTemplate;
	}

	@Override
	public PutFileResp putFile(PutFileReq req) {
		Map<String, String> params = Maps.newHashMap();
		params.put("siteId", req.getSiteId());
		params.put("fileSuffix", req.getFileSuffix());
		params.put("rootOrgId", String.valueOf(req.getRootOrgId()));
		params.put("userId", String.valueOf(req.getUserId()));
		params.put("filePath", req.getFilePath());

		return postForm("upyun/putFile", params, new File(req.getFilePath()), PutFileResp.class);
	}

}
